<main data-component="zoom">
  <form [formGroup]="zoomForm">
    <div class="grid-container">
      <div class="grid-item">
        <mat-form-field
          floatLabel="always">
          <mat-label>Integration Time</mat-label>
          <input
            matInput
            placeholder="Enter value..."
            formControlName="integrationTime"
            title="On-source integration time"
            (ngModelChange)="paramChange()">
          <span matSuffix class="mat-form-field-suffix">hours</span>
            <mat-error>
                {{ getErrorMessage(integrationTime) }}
            </mat-error>
        </mat-form-field>

        <mat-form-field
          floatLabel="always">
          <mat-label>Central Frequency</mat-label>
          <input
            matInput
            placeholder="Enter value..."
            formControlName="centralFrequency"
            required
            min="{{centralFrequencyLimits.min}}"
            max="{{centralFrequencyLimits.max}}"
            title="The central frequency of the observation"
            (ngModelChange)="centralFrequencyChange()">
          <span matSuffix class="mat-form-field-suffix">MHz</span>
          <mat-error *ngIf="centralFrequency?.invalid">
            {{ getErrorMessage(centralFrequency) }}
          </mat-error>
        </mat-form-field>

        <mat-form-field
          floatLabel="always" title="Zoom Bandwidth and Spectral Resolution">
          <mat-label>Bandwidth, Spectral Resolution</mat-label>
          <mat-select
            formControlName="bandwidthAndSpectralResolution"
            (selectionChange)="bandwidthAndSpectralResolutionChange()">
            <ng-container *ngFor="let obj of bandwidthAndSpectralResolutionOptions">
                <mat-option [value]="obj">{{bandwidthAndSpectralResolutionDisplayValue(obj.spectralResolutionHz, obj.totalBandwidthKhz)}}</mat-option>
            </ng-container>
          </mat-select>
          <mat-error>
            {{getErrorMessage(bandwidthAndSpectralResolution)}}
          </mat-error>
        </mat-form-field>

        <article style="width: 97%;">
          <mat-form-field floatLabel="always" title="Factor by which the intrinsic resolution should be averaged">
              <mat-label>Spectral Averaging</mat-label>
                      <input
            matInput
            placeholder="Enter value..."
            type="number"
            formControlName="spectralAveraging"
            required
            min="{{spectralAveragingLimits.min}}"
            max="{{spectralAveragingLimits.max}}"
            (ngModelChange)="spectralAveragingChanged()">
              <mat-error>{{getErrorMessage(spectralAveraging)}}</mat-error>
          </mat-form-field>

          <mat-form-field floatLabel="always" title="Spectral resolution after averaging">
              <mat-label>Effective Resolution</mat-label>
              <input matInput value="{{effectiveSpectralResolutionDisplayValue}}" readonly>
            <mat-error>{{getErrorMessage(effectiveSpectralResolutionHz)}}</mat-error>
          </mat-form-field>
        </article>

        <article style="width: 97%;">
                  <mat-form-field title="Select an image weighting option">
                      <mat-label>Image Weighting</mat-label>
                      <mat-select formControlName="imageWeighting"
                                  (selectionChange)="weightingChanged()"
                                  required>
                          <ng-container *ngFor="let item of imageWeightingOptions">
                              <mat-option [value]="item">{{item}}</mat-option>
                          </ng-container>
                      </mat-select>
                  </mat-form-field>

                  <mat-form-field *ngIf="showRobustness"
                                  style="margin-right: 10px;"
                                  title="Select a robustness">
                      <mat-label>Robust Value</mat-label>
                      <mat-select formControlName="robust"
                                  (selectionChange)="paramChange()"
                                  required>
                          <ng-container *ngFor="let robustness of robustOptions">
                              <mat-option [value]="robustness">{{robustness}}</mat-option>
                          </ng-container>
                      </mat-select>
                  </mat-form-field>
              </article>
      </div>
      <div class="grid-item">
        <app-zoom-results [lowZoomResults]="lowZoomResults"></app-zoom-results>
      </div>
    </div>
  </form>
</main>
